> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/custom-code-actions/run-python-procedure.md).

# Run Python Procedure

## Run Python Procedure Actions

### Process / ProcessPython

Passes the requested event to a Python interface for processing. Event metadata fields applicable for this action are as follows:

{% tabs %}
{% tab title="Table" %}

| Field          | Definition                             | Example    | Default |
| -------------- | -------------------------------------- | ---------- | ------- |
| Input Element  | Json path of payload input to pass     | parameters | -       |
| Output Element | Json path for output to add on payload | $          | -       |
| {% endtab %}   |                                        |            |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "title": "Run Python Procedure Process/ProcessPython action eventMeta fields",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "inputElement": {
          "type": "string",
          "definition": "Json path of payload input to pass",
          "example": "parameters",
          "default": null
        },
        "outputElement": {
          "type": "string",
          "definition": "Json path for output to add on payload",
          "example": "$",
          "default": null
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With event metadata parameters as:

{% tabs %}
{% tab title="Table" %}

| Parameter      | Definition                                 | Example         | Default |
| -------------- | ------------------------------------------ | --------------- | ------- |
| Input Pattern  | JMESPath pattern to apply on input element | {data:contents} | -       |
| Python Package | Name of the Python package to use          | rierino\_runner | -       |
| Python Module  | Name of the Python module to use           | CustomHandler   | -       |
| Python Action  | Name of the Python function to call        | Calculate       | -       |
| {% endtab %}   |                                            |                 |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "title": "Run Python Procedure Process/ProcessPython action eventMeta.parameters",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "inputPattern": {
              "type": "string",
              "definition": "JMESPath pattern to apply on input element",
              "example": "{data:contents}",
              "default": null
            },
            "pyPackage": {
              "type": "string",
              "definition": "Name of the Python package to use",
              "example": "rierino_runner",
              "default": null
            },
            "pyModule": {
              "type": "string",
              "definition": "Name of the Python module to use",
              "example": "CustomHandler",
              "default": null
            },
            "pyAction": {
              "type": "string",
              "definition": "Name of the Python function to call",
              "example": "Calculate",
              "default": null
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
The Python function receives the Java handler, the processed input as a dict, and the event metadata parameters.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/custom-code-actions/run-python-procedure.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
